#! /usr/bin/env python
# -*- coding: utf-8 -*-

# Script generating nautilus script for comfortable run 
# BlackBox Component Builder on Linux with Wine from context menu

# Usage: run the script on the folder of BlackBox Component Builder
# Then: call BlackBox in any folder in server mode from the context menu

import os, sys

# make context.menu runner
name = "BlackBox"
OUT = open(name, "w")
print >> OUT, "#!/bin/sh"
cwd = os.getcwd()
print >> OUT, "wine '"+cwd+"/BlackBox.exe' -use \"`winepath -w \"$PWD\"`\" $* &"
os.system('chmod +x "'+name+'"')
os.system('mv "'+name+'" ~/.gnome2/nautilus-scripts/ ')


# add aplication to dash
# need the file:  Win/Rsrc/icon.svg
OUT = open("blackbox.desktop", "w")
print >> OUT, "[Desktop Entry]"
print >> OUT, "Encoding=UTF-8"
print >> OUT, "Name=BlackBox Component Builder"
print >> OUT, "Comment=BlackBox is a compiler and a software framework for the Component Pascal language"
folder = ""
try:
    sys.argv[1]
except IndexError:
	foo = raw_input('Хотите ли вы использовать отдельную папку для проектов? [y/n] ')
	if str(foo) == 'y':
		folder = raw_input('Введите полный путь к папке [Пример:/home/username/projects]:\n')
	else:
		print >> OUT, "Exec=wine '"+cwd+"/BlackBox.exe'"
		print >> OUT, "Path="+cwd
else:
	folder = sys.argv[1]

if folder != "":
	if os.path.exists(folder) == 0:
		os.system('mkdir '+folder)
	home = os.getenv("HOME")
	if os.path.exists(home+'/.blackbox') == 0:
		os.system('mkdir '+home+'/.blackbox')
	OUT2 = open(home+"/.blackbox/blackboxStart", "w")
	print >> OUT2, "#!/bin/sh"
	print >> OUT2, "wine '"+cwd+"/BlackBox.exe' -use \"`winepath -w \""+folder+"\"`\" $* &"
	os.system("chmod +x "+home+"/.blackbox/blackboxStart")

	print >> OUT, "Exec="+home+"/.blackbox/blackboxStart"
	print >> OUT, "Path="+folder

print >> OUT, "Icon="+cwd+"/Win/Rsrc/icon.svg"
print >> OUT, "Categories=Programming"
print >> OUT, "Version=1.6rc6"
print >> OUT, "Type=Application"
print >> OUT, "Terminal=0"
print >> OUT, "Name[ru_RU]=БлэкБокс"
os.system("mv blackbox.desktop ~/.local/share/applications/")


# Ivan Denisov, 2012
# d.ivan.krsk@gmail.com

